



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>通过设计让APP变快的6个方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">通过设计让APP变快的6个方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:29:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>我们都知道不管网页还是移动应用，响应速度都是最重要的体验指标之一，并且移动应用的网络环境不稳定，速度的体验显得尤为重要。其实速度优化不仅是程序员的事，设计，也能够让APP变得更快。</p>
<p>　　<strong>1. 后台执行</strong></p>
<p>　　这是一条很通用，也容易理解的方法。用户不会愿意盯着进度条傻傻地等待，除了&ldquo;取消&rdquo;没有其他选择。在系统处理一些网络任务的时候，完全可以允许用户做一些其他的事情。</p>
<p>　　各大平台的发微博，都采用了后台执行。云阅读的离线下载也采用后台执行。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163029-b1a70d2766704725bd4d65661834bea4.png" /></p>
<p>　　而微博的看长图(或视频)，是个反例。网络不给力时，要么等待1分钟让图加载完，要不就只好放弃看图。为什么不能让图加载的同时，用户可以看其他微博呢？</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163028-68cf67da68b14b3b820b19da96cabd39.png" /></p>
<p>　　<strong>2. 在载入前显示内容</strong></p>
<p>　　客户端与web的一个不同点，客户端的显示内容包括本地数据和网络数据两部分。在设计界面时，将更多的信息放在本地，在网络数据未载入时即显示本地数据，让用户产生一种&ldquo;已经载入一半了&rdquo;的错觉，即使最终的耗时一样，心理感受也会更快。当然把数据过多地写在本地，会牺牲一些灵活性，需要根据具体情况考虑。</p>
<p>　　具体请看twitter、Facebook、Vine等优秀产品的启动画面，虽然同是静态图片，但它们不使用LOGO而假装已经载入了&ldquo;导航栏&rdquo;和&ldquo;标题栏&rdquo;，让人感觉&ldquo;点击后立即就启动了&rdquo;。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163029-ce5ec0f1dabb418f9dba38048a76245f.png" /></p>
<p>　　再如App Store的详情页，在详细信息载入前，已有信息先显示。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163030-b034700bd10a4ea9a5135c59576b2a12.png" /></p>
<p>　　<strong>3. 充分利用好缓存</strong></p>
<p>　　缓存可以把网络数据保存在本地，下次打开时无需要再次向网络请求，减少流量并减少等待时间。在设计时，可以先显示缓存内容，同时后台到网络上拉取新内容，若有新内容立即替换或下次访问时替换。但缓存使用也要注意&ldquo;度&rdquo;，过大的缓存文件占用太多的系统空间，会让用户一怒之下卸载APP。</p>
<p>　　云阅读的&ldquo;书城&rdquo;和&ldquo;通过微博找好友&rdquo;等界面，都使用了缓存机制，提高打开页面的速度。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163030-08bb9443dc51417f8001d145e06672c2.png" /></p>
<p>　　<strong>4. 界面先行，网络交互随后</strong></p>
<p>　　对于一些数据量很小，且失败可能性较小的网络交互，用户并不需要明确知道APP在干这些事情，也能够顺畅地使用APP，那么我们就应该&ldquo;把一些事实掩盖起来&rdquo;，即界面上听话地、迅速地完成任务(心智模型)，程序后台默默地继续执行任务(实现模型)。</p>
<p>　　最常用的比如QQ、微信、易信等聊天界面。点击发送后，消息立即&rdquo;飞&rdquo;到聊天上下文中，其实对方还没收到。但这样的设计让沟通的过程更顺畅，没有&ldquo;正在发送 &ndash; 发送成功&rdquo;各种过程的干扰。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163030-02fb3d66ba694a1395f0f6c3c7ded080.png" /></p>
<p>　　用户在收藏文章，关注好友等操作时，数据量很小，可以界面先行。用户在继续浏览文章的同时，系统会把文章收藏好。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163031-cdeb1e12d1ea44da83b340a4ce5112ac.png" /></p>
<p>　　与此思路相仿的另一种方法也常被用到：在无网络条件下，用户进行操作(比如写评论，写备注等)，把用户的输入内容保存在本地，等到有网络时再上传。让用户有连贯的体验。</p>
<p>　　<strong>5. 预测用户行为，提前开始任务</strong></p>
<p>　　不知道大家使用淘宝有没有这样的习惯，在搜索结果列表，将所有感兴趣的结果都打开为新标签页，然后一个个地看，没兴趣的就关闭。这样做的好处是，在我浏览商品详情页的时候，每个页面都是载入完全了，否则我点开一个看一个，每个都要等待加载完，就会大大降低效率。</p>
<p>　　那么能否通过设计，来满足类似使用场景呢？应该是可以的，那就是预测用户的行为，提前开始任务。</p>
<p>　　策略类似这样：</p>
<p>　　用户在某个界面停留的时候，预测下一步可能做ABC三个任务，系统于是把这些任务都提前做完。当用户做出选择比如A时，界面可以迅速响应，并且同时把BC两个任务从内存中清空掉以节省资源。(当然这招也有限制：1，只适用于免费的网络。2，预加载不能影响系统的性能)</p>
<p>　　我们就回来看淘宝的iPad客户端。它有这样的设计，在某详情页查看时，向右一划可以查看下一个商品，也许这是一个好设计，但是却没有帮我预加载下一个界面，我还是不得不傻傻地等页面加载完。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163031-9c0d8f152d1f4c78b2fb5f3959bcf6c9.png" /></p>
<p>　　那我们看一些其他的设计</p>
<p>　　在网易云阅读，我们认为用户进入一个资讯源的一个最大可能就是刷新查看新内容。所以即使没有打开自动刷新选项时，进行源列表，后台自动加载新内容，并在刷新按钮上显示&ldquo;NEW&rdquo;，此时当用户再刷新，内容立即呈现。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163031-f19d07d64dc043e1966a98e35f233a67.png" /></p>
<p>　　Android更新提醒在安装包自动下载完成之后提示，让用户不再需要等待下载过程。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163032-dbb552b271ed48cfbb55cfea52342ec9.jpg" /></p>
<p>　　再比如云阅读的查看大图，自动载入下一张;TableView在将要达到底部时自动载入等。</p>
<p>　　Chrome在下载前询问是否保存，在用户决定之就已经开始下载，节省了不少时间。如果用户放弃，已下载内容会自动删除。</p>
<p>　　那么，用这个思路</p>
<p>　　写微博插入照片后，能否自动上传，而不必等用户点击了&ldquo;发送&rdquo;才上传？</p>
<p>　　看微博时定位到某条微博，是否应该自动加载大图或视频？</p>
<p>　　音乐应用在当前歌曲快播放完时，是否应该下载下一首歌，以免切歌的时候会卡一会儿？</p>
<p>　　<strong>6. 使用动效来掩护载入过程</strong></p>
<p>　　优秀的动效设计，让产品更好用且让人眼前一亮。其实，动效还有另一大用处，吸引用户的注意，让本来枯燥的等待载入的过程，变成愉悦欣赏的过程。</p>
<p>　　以下两个例子来源于网络</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163032-4bdf9507f0054a6b9909f2fb314c59af.gif" /></p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/news/24634/201311/04163033-32a7bfba73674d22bc449fb6b244865b.gif" /></p>
<p>　　最后，感谢这篇文章的作者，<a href="http://www.boxui.com/ued/interaction-design/8425.html" rel="external nofollow noreferrer">移动产品设计的八大设计原则</a></p>
<p>　　有些观点来源于此，但我加入了自己的理解和更多的例子，希望对大家有所启发。</p>
<p><a href="http://uedc.163.com/11291.html" rel="external nofollow noreferrer">http://uedc.163.com/11291.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1k409g.html">css中的浮动与三种清除浮动的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jk2e85.html">C标准头文件&amp;lt&semi;math&period;h&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jxe3wq.html">CSRF攻击与防御</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4vglnq.html">Spring 数据库配置用户名和密码加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kel5r8.html">ng-bind&comma;ng-cloak优化数据显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq103r08.html">CodeForces 559C Gerald and Giant Chess</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0xyvq.html">Blocks   推出矩阵公式。矩阵快速密</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm50o09.html">System&period;Data&period;Entity&period;Internal&period;AppConfig 类型初始值设定项引发异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvo0nyq.html">切割TOMCAT日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv6rlzq.html">eclipse的优化 gc&period;log</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mezkxpq.html">centos利用yum安装卸载软件常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge0jke8.html">VSCode插件MSSQL教程（昨天提了一下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjdxz8.html">CAS 之 Hello World（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0z7m8.html">Mybatis-简单基于源码了解获取动态代理对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp74269.html">element 给table的个别表格框添加样式 ---重构里面的组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yzrnr8.html">【XSY3344】连续段 DP 牛顿迭代 NTT</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0mndq.html">Nginx实现集群服务器的负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5y50rq.html">一个小误区 JS中的contains</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwkyoz8.html">【noip 2012】提高组Day2T3&period;疫情控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv5pzl8.html">linux 测试 get 请求 跳过SSL证书验证</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qydkygdq.html">Basefragment的封装使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzpln9.html">delphi7编写客户端调用java服务器端webservice示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde25379.html">&lbrack;LeetCode&rsqb; Maximum Gap 解题思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1wrr19.html">深入理解linux网络技术内幕读书笔记&lpar;五&rpar;--网络设备初始化</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzdn09.html">eclipse svn插件安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn0lwrq.html">Scala-变量、常量和懒加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z34449.html">js解析json，js转换json成map&comma;获取map的key&comma;value</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn0krrq.html">查看android进程信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ol228.html">分享一次在Windows Server2012 R2中安装SQL Server2008</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oeg7j9.html">转载&mdash;&mdash;SQL Server中Rowcount与&commat;&commat;Rowcount的用法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
